/*******************************************************
	LN^OLED\tg
********************************************************/

#include <string.h>
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h> 
#include <avr/power.h>
#include <util/delay.h>
#include "user_defs.h"

// ֐vg^Cv
void OLED_init(void);
void OLED_display(void);

void SendCommand(uint8_t);
void SendData(uint8_t);

void SendSerial1Byte(uint8_t);
void SendSerial1Bit(uint8_t);

// ϐ
uint8_t VRAM_buffer[16*2];	// OLED-VRAMobt@
static uint8_t VRAM_bak[16*2];	// VRAMMς݃obt@
static uint8_t VRAM_check_position;	// VRAMobt@`FbNʒu
static uint8_t VRAM_send_position;	// VRAMobt@Mʒu

uint8_t OLED_sequence_number;	// VRAM݃V[PXԍ
uint8_t VRAM_address;			// VRAMf[^MAhX


// EEPROM.c
extern uint32_t Ext_EEPROM_addr;	// EEPROMANZXAhX

// main.c
extern uint8_t Rec_buffer[EEPROM_read_page_size * 2];	// L^/Đobt@
extern uint16_t Rec_buffer_index;			// L^݈ʒu
extern uint16_t Play_buffer_index;			// Đ݈ʒu@Rec_buffer_indexœłȂH
extern uint8_t select_block;				// EEPROMIubNԍ


// esVRAMAhXݒ{R}h
static const uint8_t PROGMEM LineTopAddress[]={
	0x00 | 0x80,
	0x40 | 0x80,
};

/*******************************************************
	C
********************************************************/
void OLED_sequence(void){
	uint8_t temp_VRAM_address;

	switch(OLED_sequence_number){
	case 0:
		// VRAMe̕ω`FbN
		if(VRAM_buffer[VRAM_check_position] != VRAM_bak[VRAM_check_position]){
			// ω΃V[PXi߂
			VRAM_bak[VRAM_check_position] = VRAM_buffer[VRAM_check_position];
			VRAM_send_position = VRAM_check_position;
			OLED_sequence_number++;
		}
		VRAM_check_position++;
		if(VRAM_check_position >= ELEMENT(VRAM_buffer)){
			VRAM_check_position = 0;
		}
	break;

	case 1:
		temp_VRAM_address = pgm_read_byte(&LineTopAddress[((VRAM_send_position >> 4) & 1)]) | (VRAM_send_position & 0x0f);
		// \VRAMAhXƌݒlɍق΍XV
		if(temp_VRAM_address != VRAM_address){
			VRAM_address = temp_VRAM_address;
			SendCommand(VRAM_address);
		}
		OLED_sequence_number++;
	break;

	case 2:
		// \f[^̓]
		SendData(VRAM_buffer[VRAM_send_position]);
		VRAM_address++;	// lɃCNgĂOKI
		if(VRAM_check_position >= ELEMENT(VRAM_buffer)){
			VRAM_check_position = 0;
		}
		OLED_sequence_number = 0;
	break;

	default:
		OLED_sequence_number = 0;
	break;
	}
}

void OLED_init(void){
// fWbgɂƁAd500ms҂ȂƂȂ炵B
//	_delay_ms(500);	// Af[^V[gɂ͂ȎĂւ
	_delay_ms(10);	// f[^V[gł10msƂȂƂ

	// t@NVZbg
	// DL=1 8rbg[h
	// N=1 2s\
	// F=0 5x8tHgTCY
	// FT1=0,FT0=0 p/{tHg
	SendCommand(0b00111000);

	// f/p[
	// G/C=0
	// PWR=0
	SendCommand(0b00010011);
	//   bit:76543210

	// \ON/OFF
	// D=1
	// C=1
	// B=1
	SendCommand(0b00001000);

	// Gg[[h
	// I/D=1
	// S=0
	SendCommand(0b00000110);

	// J[\/\Vtg
	// S/C=1
	// R/L=1
	SendCommand(0b00010100);

	// f/p[
	// G/C=0
	// PWR=1
	SendCommand(0b00010111);
//	SendCommand(0b00011111);	// OtBbN[h

	// \NA
	SendCommand(0b00000001);
	_delay_ms(7);	// f[^V[gł6.2ms

	// J[\z[
	SendCommand(0b00000010);

	// \ON/OFF
	// D=1
	// C=1
	// B=1
	SendCommand(0b00001100);


//	SendCommand(0x80);	//|WVZbg

	VRAM_check_position = 0;
	VRAM_address = 0xff;
	memset(VRAM_bak,0xff,ELEMENT(VRAM_bak));


}

// R}hM
void SendCommand(uint8_t cmd){
	OLED_CS_L();
	SendSerial1Bit(L);	// RS
	SendSerial1Bit(L);	// R/W
	SendSerial1Byte(cmd);
	OLED_CS_H();
}

void SendData(uint8_t dat){
	OLED_CS_L();
	SendSerial1Bit(H);	// RS
	SendSerial1Bit(L);	// R/W
	SendSerial1Byte(dat);
	OLED_CS_H();
}

void SendSerial1Byte(uint8_t dat){
	uint8_t i;
	for(i=0;i<8;i++){
		SendSerial1Bit(dat & _BV(7-i));
	}
}

void SendSerial1Bit(uint8_t bit){
	OLED_SCL_L();
	if(bit == 0){
		OLED_SDO_L();
	}else{
		OLED_SDO_H();
	}
	OLED_SCL_H();
}

extern uint8_t Progress[3];				// ԑJڊǗf[^
extern const uint8_t PROGMEM Hex2Chr[16*2];
extern uint8_t menu_number;
extern uint8_t RS232C_speed;
extern uint8_t TWI_speed;
extern uint8_t BEEP_volume;

const uint8_t PROGMEM main_menu_str[][16]={
//	 0123456789ABCDEF
	"STOP            ",	// 0
	"PLAY:           ",	// 1
	"REC:            ",	// 2
	"DUMP:           ",	// 3
	"LOAD:           ",	// 4
	"USER CONFIG     ",	// 5
	"SYNC ERROR      ",	// 6
	"PS-PAD ERROR    ",	// 7
};

const uint8_t PROGMEM user_setting_menu_str[][16]={
//	 0123456789ABCDEF
	"SELECT BLOCK:   ",
	"RS232C:      bps",
	"TWI:            ",
	"VOLUME:         ",
};


static const uint8_t PROGMEM RS232C_speed_str_tbl[][6]={
	"   300",
	"   600",
	"  1200",
	"  2400",
	"  4800",
	"  9600",
	" 19200",
	" 38400",
	" 57600",
	"115200",
};

void OLED_display(void){
	switch(menu_number){
		case 0:
		if(Progress[target] == progress_dump){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[3][0],ELEMENT(main_menu_str[0]));
			VRAM_buffer[5] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr - ELEMENT(Rec_buffer) + Play_buffer_index) >> 16) & 0x0f]);
			VRAM_buffer[6] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr - ELEMENT(Rec_buffer) + Play_buffer_index) >> 12) & 0x0f]);
			VRAM_buffer[7] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr - ELEMENT(Rec_buffer) + Play_buffer_index) >> 8) & 0x0f]);
			VRAM_buffer[8] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr - ELEMENT(Rec_buffer) + Play_buffer_index) >> 4) & 0x0f]);
			VRAM_buffer[9] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr - ELEMENT(Rec_buffer) + Play_buffer_index)) & 0x0f]);
		}else if(Progress[target] == progress_load){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[4][0],ELEMENT(main_menu_str[0]));
			VRAM_buffer[5] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 16) & 0x0f]);
			VRAM_buffer[6] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 12) & 0x0f]);
			VRAM_buffer[7] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 8) & 0x0f]);
			VRAM_buffer[8] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 4) & 0x0f]);
			VRAM_buffer[9] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index)) & 0x0f]);
#if 0
		}else if((PS_comminucation_error & SYNC_ERROR) != 0){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[6][0],ELEMENT(main_menu_str[0]));
		}else if((PS_comminucation_error & PSPAD_ERROR) != 0){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[7][0],ELEMENT(main_menu_str[0]));
#endif
		}else if(Progress[target] == progress_stop){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[0][0],ELEMENT(main_menu_str[0]));
		}else if(Progress[target] == progress_record){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[2][0],ELEMENT(main_menu_str[0]));
			VRAM_buffer[4] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 16) & 0x0f]);
			VRAM_buffer[5] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 12) & 0x0f]);
			VRAM_buffer[6] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 8) & 0x0f]);
			VRAM_buffer[7] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index) >> 4) & 0x0f]);
			VRAM_buffer[8] = pgm_read_byte(&Hex2Chr[((Ext_EEPROM_addr + Rec_buffer_index)) & 0x0f]);
		}else if(Progress[target] == progress_play){
			memcpy_P(&VRAM_buffer[0],&main_menu_str[1][0],ELEMENT(main_menu_str[0]));
		}else{
		}
		memcpy_P(&VRAM_buffer[16],&user_setting_menu_str[0][0],ELEMENT(main_menu_str[0]));
		VRAM_buffer[16+13] = pgm_read_byte(&Hex2Chr[select_block & 0x07]);
		break;

		case 1:	// RS232C
		memcpy_P(&VRAM_buffer[0],&main_menu_str[5][0],ELEMENT(main_menu_str[0]));
		memcpy_P(&VRAM_buffer[16],&user_setting_menu_str[1][0],ELEMENT(main_menu_str[0]));
		memcpy_P(&VRAM_buffer[16+7],&RS232C_speed_str_tbl[RS232C_speed],ELEMENT(RS232C_speed_str_tbl[0]));
		break;

		case 2:	// TWI
		memcpy_P(&VRAM_buffer[0],&main_menu_str[5][0],ELEMENT(main_menu_str[0]));
		memcpy_P(&VRAM_buffer[16],&user_setting_menu_str[2][0],ELEMENT(main_menu_str[0]));
		VRAM_buffer[16+4] = pgm_read_byte(&Hex2Chr[(TWI_speed >> 4)]);
		VRAM_buffer[16+5] = pgm_read_byte(&Hex2Chr[(TWI_speed & 0x0f)]);
		break;

		case 3:	// VOLUME
		memcpy_P(&VRAM_buffer[0],&main_menu_str[5][0],ELEMENT(main_menu_str[0]));
		memcpy_P(&VRAM_buffer[16],&user_setting_menu_str[3][0],ELEMENT(main_menu_str[0]));
		VRAM_buffer[16+7] = pgm_read_byte(&Hex2Chr[BEEP_volume]);
		break;

		default:
		break;
	}
}
