/*******************************************************
	LN^OLED\tg
********************************************************/

#include <stdio.h>
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h> 
#include <avr/power.h>
#include <util/delay.h>
#include "user_defs.h"

// ֐vg^Cv
void OLED_test(void);

static void SendCommand(uint8_t);
static void SendData(uint8_t);

static void SendSerial1Byte(uint8_t);
static void SendSerial1Bit(uint8_t);
static uint8_t RecvSerial1Bit(void);
static uint8_t RecvSerial1Byte(void);


// ̌䌾t
const uint8_t PROGMEM deathler[4][20]= {
//   01234567890123456789
	"׽  ĺ   ",	// 2s^Cvp
	"ֳޡ              ",
};

// esVRAMAhXݒ{R}h
static const uint8_t LineTopAddress[]={
	0x00 | 0x80,
	0x40 | 0x80,
};

// ϐ

//0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000,0b00000000
volatile uint8_t tmp;

/*******************************************************
	C
********************************************************/
void OLED_test(void){
	uint8_t x,y;

// fWbgɂƁAd500ms҂ȂƂȂ炵B
//	_delay_ms(500);	// Af[^V[gɂ͂ȎĂւ
	_delay_ms(10);	// f[^V[gł10msƂȂƂ

	// t@NVZbg
	// DL=1 8rbg[h
	// N=1 2s\
	// F=0 5x8tHgTCY
	// FT1=0,FT0=0 p/{tHg
	SendCommand(0b00111000);

	// f/p[
	// G/C=0
	// PWR=0
	SendCommand(0b00010011);
	//   bit:76543210

	// \ON/OFF
	// D=1
	// C=1
	// B=1
	SendCommand(0b00001111);

	// Gg[[h
	// I/D=1
	// S=0
	SendCommand(0b00000110);

	// J[\/\Vtg
	// S/C=1
	// R/L=1
	SendCommand(0b00010100);

	// f/p[
	// G/C=0
	// PWR=1
	SendCommand(0b00010111);
//	SendCommand(0b00011111);	// OtBbN[h

	// \NA
	SendCommand(0b00000001);
	_delay_ms(7);	// f[^V[gł6.2ms

	// J[\z[
	SendCommand(0b00000010);

//	SendCommand(0x80);	//|WVZbg

	for(y = 0;y < ELEMENT(deathler);y++){
		tmp = pgm_read_byte(&LineTopAddress[y]);
		SendCommand(pgm_read_byte(&LineTopAddress[y]));	//|WVZbg
		for(x = 0;x < ELEMENT(deathler[0]);x++){
			SendData(pgm_read_byte(&deathler[y][x]));
		}
	}
}

// R}hM
static void SendCommand(uint8_t cmd){
	OLED_CS_L();
	SendSerial1Bit(L);	// RS
	SendSerial1Bit(L);	// R/W
	SendSerial1Byte(cmd);
	OLED_CS_H();
}

static void SendData(uint8_t dat){
	OLED_CS_L();
	SendSerial1Bit(H);	// RS
	SendSerial1Bit(L);	// R/W
	SendSerial1Byte(dat);
	OLED_CS_H();
}

static void SendSerial1Byte(uint8_t dat){
	uint8_t i;
	for(i=0;i<8;i++){
		SendSerial1Bit(dat & _BV(7-i));
	}
}

static void SendSerial1Bit(uint8_t bit){
	OLED_SCL_L();
	if(bit == 0){
		OLED_SDO_L();
	}else{
		OLED_SDO_H();
	}
	OLED_SCL_H();
}

// VA1oCgM
static uint8_t RecvSerial1Byte(void){
	uint8_t recv;
	uint8_t i;

	OLED_CS_L();

	recv = 0;

	// [hR}h𔭍s
	SendSerial1Bit(L);	// RS
	SendSerial1Bit(H);	// R/W
	for(i=0;i<8;i++){
		SendSerial1Bit(0);
	}

	// Rg[rbgAOl߂őĂ炵
	recv <<= 1;
	SendSerial1Bit(L);	// RS
	recv |= RecvSerial1Bit();

	recv <<= 1;
	SendSerial1Bit(H);	// R/W
	recv |= RecvSerial1Bit();

	for(i=0;i<8;i++){
		SendSerial1Bit(0);
		// 8rbgf[^̂AŏI2rbg_~[ƂȂ
		if(i < 6){
			recv <<= 1;
			recv |= RecvSerial1Bit();
		}
	}
	OLED_CS_H();

	return recv;
}

// VA1rbgM
static uint8_t RecvSerial1Bit(void){
	uint8_t result;

	result = 0;
	if(OLED_SDI != 0){
		result = 1;
	}
	return result;
}

