/*******************************************************
	LN^OLED\tg
********************************************************/

//#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h> 
//#include <avr/power.h>
#include <util/delay.h>
#include <util/twi.h>
#include "user_defs.h"
#include "InitSFR.h"

// ֐vg^Cv
void InitSFR(void);

void EEPROM_test(void);
uint8_t getIIC1stCmd(uint32_t addr,uint8_t access);
void I2CStart(void);
void I2CStop(void);
uint8_t I2CWrite(uint8_t dat);
uint8_t I2CRead(uint8_t ack);


volatile uint8_t tmp;
uint8_t PS_command_buffer_index;
uint8_t PS_data_size;

#if 1
uint8_t PS_command_buffer[256];
uint8_t PS_data_buffer[256];
#else
uint8_t PS_command_buffer[32+3];
uint8_t PS_data_buffer[32+3];
#endif

uint32_t Ext_EEPROM_addr;

// OLED.c
void OLED_test(void);

#if 1
#endif

/*******************************************************
	C
********************************************************/
int main(){
	cli();											// ݋֎~
	InitSFR();										// SFR

	OLED_test();

	Ext_EEPROM_addr = 0x40000;

	PS_command_buffer_index = 0;
	PS_data_size = 32;

//	memset(PS_command_buffer, 0, ELEMENT(PS_command_buffer));
//	memset(PS_data_buffer, 0, ELEMENT(PS_data_buffer));

	EEPROM_test();
	
	sei();
	while(1){
#if 0
		PS_command_buffer[PS_command_buffer_index] = 0;
		while(PSBASE_SEL == L);
		while(PSBASE_SCL == H);
		for(i=0;i<8;i++){
			while(PSBASE_SCL == L);
			PSBASE_command_buffer[PSBASE_command_buffer_index] =
				(PSBASE_command_buffer[PSBASE_command_buffer_index] >> 1);
			if(PSBASE_SDO != 0){
				PSBASE_command_buffer[PSBASE_command_buffer_index] |= 0x80;
			}
			while(PSBASE_SCL == H);
		}
		PSBASE_command_buffer_index++;
#endif
	}
}

volatile uint8_t temp;
volatile uint8_t dat;
volatile uint8_t flag;
volatile uint8_t wait_count;
void EEPROM_test(void){

	I2CStart();				// X^[gERfBV ҂L

	temp = getIIC1stCmd(Ext_EEPROM_addr,1);

	if(!I2CWrite(temp)) {	// CB Adrs=50(W)
		// NOACK
		I2CStop();			// XgbvERfBVs
	}else{
		I2CWrite(0x00);			// ROM Adrs(H) ҂L
		I2CWrite(0x00);			// ROM Adrs(L) ҂L
		I2CWrite(0xaa);			// CB Adrs=50(R) ҂L
		I2CWrite(0x55);			// CB Adrs=50(R) ҂L
//		I2CWrite(0xaa);			// CB Adrs=50(R) ҂L
		I2CStop();			// XgbvERfBVs

#if 0	// busy`FbNAPEFCg
		_delay_ms(10);
		I2CStart();				// X^[gERfBV ҂L
		temp = getIIC1stCmd(Ext_EEPROM_addr,1);
		I2CWrite(temp);			// CB Adrs=50(W) ҂L
#else	// busy`FbN
		flag = false;
		wait_count = 0;
		temp = getIIC1stCmd(Ext_EEPROM_addr,1);
		while(flag == false){
			I2CStart();				// X^[gERfBV ҂L
			flag = I2CWrite(temp);	// ҂L
			wait_count++;
		}
#endif

		I2CWrite(0x00);			// ROM Adrs(H) ҂L
		I2CWrite(0x00);			// ROM Adrs(L) ҂L

		//[hEV[PX
		I2CStart();				// s[gEX^[gERfBV ҂L

		temp = getIIC1stCmd(Ext_EEPROM_addr,0);
		I2CWrite(temp);			// CB Adrs=50(R) ҂L

		// 1oCgڂ̃f[^ǂݏo
		dat = I2CRead(0);		// oCgE[h(ACK) ҂L

		// datɌ(1st data)
		//
		// Mf[^̊mF(ROMAhX0x1234ROMf[^0x56ĂƂO)
		//
		if(dat == 0x56) {
			// v
//			LED2_ON;
		} else {
			// sv
//			LED2_OFF;
		}

		// 2oCgڂ̃f[^ǂݏo
		dat = I2CRead(1);		// oCgE[h(NOACK) ҂L
		// datɌ(2nd data)

		I2CStop();				// XgbvERfBVs
	}
}

ISR(SPI_STC_vect){
	PS_data_buffer[PS_command_buffer_index] = PIND;
	PS_command_buffer[PS_command_buffer_index] = SPDR;
#if 1
	if(PS_command_buffer_index == 1){
		PS_data_size = (PS_data_buffer[PS_command_buffer_index] & 0x0f) << 1;
		if(PS_data_size == 0){
			PS_data_size = 32;
		}
	}
	PS_command_buffer_index++;
	if(PS_command_buffer_index >= (PS_data_size + 3)){
		// f[^t[̏I
		PS_command_buffer_index = 0;
	}
#else
	PS_command_buffer_index++;
#endif
}

ISR(TIMER0_COMPA_vect){
}

uint8_t getIIC1stCmd(uint32_t addr,uint8_t access){
	uint8_t temp;

	if(access == 0){
		temp = 0b10100001;	// [hR}h
	}else{
		temp = 0b10100000;	// CgR}h
	}
	switch(addr >> 17){
		case 0:
		case 1:
		case 2:
			// 24FC1025p
			temp |= (addr >> 16) & 0b00000110;	// `bvZNgrbg
			if((addr & 0x10000) != 0){
				temp |= 0b00001000;	// ubNZNgrbg
			}
		break;

		case 3:
			// 24FC1026p
			temp |= (addr >> 15) & 0b00001100;	// `bvZNgrbg
			if((addr & 0x10000) != 0){
				temp |= 0b00000010;	// ubNZNgrbg
			}
		break;

		default:
			temp = 0;
		break;
	}
	return temp;
}

//-----------------------------------------------------------
// X^[gERfBVs(m[}As[g̋ʂȂ)
//-----------------------------------------------------------
void I2CStart(void) {
	wait_count = 0;
	TWCR = _BV(TWINT) | _BV(TWSTA) | _BV(TWEN);

	// X^[gERfBVs ҂
	while((TWCR & _BV(TWINT)) == 0){	// TWINTZbg܂ő҂
	}
}


// -----------------------------------------------------------
// XgbvERfBVs
// -----------------------------------------------------------
void I2CStop(void) {
	TWCR = _BV(TWINT) | _BV(TWSTO) | _BV(TWEN);
}


// -----------------------------------------------------------
// oCgECg
//	in:  dat Mf[^
//	ret: true:ACK/false:NOACK
// -----------------------------------------------------------
uint8_t I2CWrite(uint8_t dat) {
	wait_count = 0;
	TWDR = dat;						// o̓f[^ݒ

	TWCR = _BV(TWINT) | _BV(TWEN);				// TWINTNA }X^MJn

	// }X^M҂
	while((TWCR & _BV(TWINT)) == 0){	// TWINTZbg܂ő҂
	}

	// ACKl̃`FbN
	switch(TW_STATUS) {			// TWPS1,0}XN
		case TW_MT_SLA_ACK:
		case TW_MR_SLA_ACK:
		case TW_MT_DATA_ACK:
			// ACKM
			return true;				// ACK
		default:
			return false;				// NOACK
	}
}


//-----------------------------------------------------------
// oCgE[h
//	in:  Acc  ACK(0)/NOACK(1)
//	out: Acc Mf[^
//-----------------------------------------------------------
uint8_t I2CRead(uint8_t ack) {
	if(ack == 0) {
		// ACK
		TWCR = _BV(TWINT) | _BV(TWEN) | _BV(TWEA);		// TWINTNA }X^MJn(ACK)
	} else {
		// NOACK
		TWCR = _BV(TWINT) | _BV(TWEN);					// TWINTNA }X^MJn(NOACK)
	}

	// f[^̎M҂
	while(!(TWCR & _BV(TWINT))) {}

	return TWDR;								// Mf[^Ԃ
}
