/*******************************************************
	RS232C
********************************************************/

#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h> 
#include "user_defs.h"


void SerialSendHEX_2dig(uint8_t data, uint8_t after_space);
void SerialSendHEX_4dig(uint16_t data, uint8_t after_space);
void SerialSendHEX_5dig(uint32_t data, uint8_t after_space);
void SerialSendString(const char *str);

extern const uint8_t PROGMEM Hex2Chr[];

uint8_t RS232C_recv_buff[16];	// RS323CMobt@
uint8_t RS232C_recv_index;		// RS232CMobt@݈ʒu
uint8_t RS232C_read_index;		// RS232CMobt@ǂݏoʒu
uint8_t RS232C_buffer_overrun;

void SerialSendHEX_2dig(uint8_t data, uint8_t after_space){
	while((UCSR3A & _BV(UDRE3)) == 0){
	}
	UDR3 = pgm_read_byte(&Hex2Chr[(data >> 4)]);

	while((UCSR3A & _BV(UDRE3)) == 0){
	}
	UDR3 = pgm_read_byte(&Hex2Chr[(data & 0x0f)]);

	if(after_space == true){
		while((UCSR3A & _BV(UDRE3)) == 0){
		}
		UDR3 = ' ';
	}
}

void SerialSendHEX_4dig(uint16_t data, uint8_t after_space){
	SerialSendHEX_2dig(data >> 8,false);
	SerialSendHEX_2dig(data,after_space);
}

void SerialSendHEX_5dig(uint32_t data, uint8_t after_space){
	while((UCSR3A & _BV(UDRE3)) == 0){
	}
	UDR3 = pgm_read_byte(&Hex2Chr[(data >> 16)& 0x0f]);
	SerialSendHEX_4dig(data,after_space);
}

void SerialSendString(const char *str){
	size_t len;
	for(len = strlen(str); len != 0; len--){
		while((UCSR3A & _BV(UDRE3)) == 0){
		}
		UDR3 = *str++;
	}
}

// RS232CM荞
ISR(USART3_RX_vect){
	RS232C_recv_buff[RS232C_recv_index] = UDR3;
	RS232C_recv_index = (RS232C_recv_index + 1) & 0x0f;
	if(RS232C_recv_index == RS232C_read_index){
		RS232C_buffer_overrun++;
	}
}
